import os
import socket
import time
import struct
from network import LoRa
from pysense import Pysense
from LTR329ALS01 import LTR329ALS01
import machine

string1 = ""
string2 = ""
string3 = ""
msg = ""

_LORA_PKG_FORMAT = "BB%ds"
_LORA_PKG_ACK_FORMAT = "BBB"
DEVICE_ID = 0x01
lora = LoRa(mode=LoRa.LORA, tx_iq=True, region=LoRa.AS923)
lora_sock = socket.socket(socket.AF_LORA, socket.SOCK_RAW)
lora_sock.setblocking(False)

while(True):
    py = Pysense()
    lt = LTR329ALS01(py)
    print("Light (channel Blue lux, channel Red lux): " + str(lt.light()))
    msg += "Light (channel Blue lux, channel Red lux): " + str(lt.light()) + '\n'
    pkg = struct.pack(_LORA_PKG_FORMAT % len(msg), DEVICE_ID, len(msg), msg)
    lora_sock.send(pkg)
    time.sleep(3)
    waiting_ack = True
    while(waiting_ack):
        recv_ack = lora_sock.recv(256)
        if (len(recv_ack) > 0):
            device_id, pkg_len, ack = struct.unpack(_LORA_PKG_ACK_FORMAT, recv_ack)
            if (device_id == DEVICE_ID):
                if (ack == 200):
                    waiting_ack = False
                    print("ACK NODE B")
                else:
                    waiting_ack = False
                    print("Message Failed")
    time.sleep(5)
